//  -*- c++ -*-

#ifndef DOCTYPEDEFS_H
#define DOCTYPEDEFS_H

#include <qdom.h>
#include <qmap.h>

/**
 *
 * @version $Id: doctypedefs.h,v 1.1 2002/03/08 00:30:18 rich Exp $
 * @author Richard Moore, rich@kde.org 
 */
class DocTypeDefs
{
public:
    DocTypeDefs();
    ~DocTypeDefs();

    bool load( const QString &file );

protected:
    class Entity {
      public:
	QString name;
    };

    class Attr {
      public:
	QString name;
    };

    class Tag {
      public:
	QString name;
	QMap<QString, Attr> attrs;
    };

    void processDefs();

    void processInfo( const QDomElement &e );

    void processTags( const QDomElement &e );
    void processTag( const QDomElement &elem );

    void processEntities( const QDomElement &e );

private:
    QDomDocument defs;

    QString name;
    QString systemid;
    QString publicid;
    QMap<QString,Tag> tags;
    QMap<QString,Entity> entities;
};

#endif // DOCTYPEDEFS_H

// Local Variables:
// c-basic-offset: 4
// End:
