//  -*- c++ -*-

#ifndef XMLINFO_H
#define XMLINFO_H

#include <qdom.h>
#include <qmap.h>

/**
 *
 * @version $Id: xmlinfo.h,v 1.1 2002/03/08 00:30:19 rich Exp $
 * @author Richard Moore, rich@kde.org 
 */
class XMLInfo
{
public:
    XMLInfo();
    ~XMLInfo();

    bool load( const QString &filename );
    bool saveInfo( const QString &filename );
    void createOutput();

    void walkTree();
    void walkElement( const QDomElement &elem );

    void processDocument( QDomDocument &doc );
    void processElement( const QDomElement &elem );
    void processDecl( const QDomElement &elem );
    void processEntity( const QDomEntity &ent );

private:
    QDomDocument doc;

    QDomDocument defs;
    QDomElement info;
    QDomElement tags;
    QDomElement entities;

    QMap<QString,QDomElement> knownTags;
};

#endif // XMLINFO_H

// Local Variables:
// c-basic-offset: 4
// End:
